import { jsx as _jsx } from "react/jsx-runtime";
import { isNumber, getControl, } from 'handie-react';
import { StringFieldStructuralWidget } from 'handie-react/dist/widgets/class';
export default class InputEditStringFieldWidget extends StringFieldStructuralWidget {
    render() {
        const props = {
            value: this.props.value,
            placeholder: this.getPlaceholder(),
            disabled: this.state.disabled,
            prefix: this.config.prefix,
            suffix: this.config.suffix,
        };
        if (this.showValidationRulesAsNative) {
            const { min, max } = this.props.field;
            if (isNumber(min)) {
                props.minLength = min;
            }
            if (isNumber(max)) {
                props.maxLength = max;
            }
        }
        const TextInput = getControl('TextInput');
        return TextInput ? (_jsx(TextInput, Object.assign({}, props, { onInput: (value) => this.onChange(value) }), void 0)) : null;
    }
}
